use lazy_static::lazy_static;
use std::{
    sync::{
        Mutex,
        Once
    },
    path::PathBuf
};
use crate::{
    state::State,
    config::Config
};

lazy_static! {
    pub static ref BULB_PATH: Mutex<PathBuf> = Mutex::new(PathBuf::new());
    pub static ref BULB_CACHE_PATH: Mutex<PathBuf> = Mutex::new(PathBuf::new());
    pub static ref BULB_STATE_PATH: Mutex<PathBuf> = Mutex::new(PathBuf::new());

    pub static ref MOD_VERSION: Mutex<&'static str> = Mutex::new("");

    // pub static ref STATE: Mutex<State> = Mutex::new(State::new());
    // pub static ref CONFIG: Mutex<Config<'static>> = Mutex::new(Config::new());
}
